<!DOCTYPE html>
<html lang="en">
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link href="../static/styles/styles.css" th:href="@{/styles/styles.css}" rel="stylesheet" />
</head>
<body>
<div class="mainBody">
    <div class="row">
        <div class="col">
            <blockquote class="blockquote">
                <p class="mb-0">Editing</p>
                <footer class="blockquote-footer"> a notice</footer>
            </blockquote>
        </div>
            <div class="col" style="text-align: right; margin: auto">
                <a class="lead respFont" id="saveButton" data-toggle="popover" th:onclick="save([[${notice}]])" title="Error" data-content="" >[Save]</a>
                <a class="lead respFont" id="deleteButton" data-toggle="popover" th:onclick="deleteNotice([[${notice.id}]])" title="Error" data-content="" >[Delete]</a>
                <a class="lead respFont" data-toggle="popover" th:onclick="returnBack([[${notice.id}]])" title="Error" data-content="" >[Return]</a>
            </div>
    </div>
    <img id="image" th:src="${notice.url}" style="right: 15vw;top: 30vh;max-width: 40px; max-height: 40px;position: absolute"/>
    <hr>
    <div class="row" style="left:0; right: 0; margin:auto; width: 60%">
        <p id="errorMsg" class="lead" style="color: red; display: none" />
        <div class="col">
            <span class="lead"> Title </span>
            <input type="text" id="title" th:value="${notice.title}" class="form-control" placeholder="Enter title" aria-label="Example text with button addon" aria-describedby="button-addon1" style="border-left: none; border-right: none; border-top: none;">
        </div>
        <div class="col">
            <span class="lead"> Image url </span>
            <input type="text" id="url" th:value="${notice.url}" oninput="checkImage(this)" class="form-control" aria-label="Example text with button addon" aria-describedby="button-addon1" style="border-left: none; border-right: none; border-top: none;">
        </div>
    </div>
    <br>
    <div class="row" style="left:0; right: 0; margin:auto; width: 60%">
        <div class="col">
            <p class="lead"> Text </p>
            <textarea id="text" th:text="${notice.text}" class="form-control" aria-label="With textarea"></textarea>
        </div>
    </div>
    <br>
</div>
</body>
<script>
    function checkImage(t) {
        if(validURL(t.value)) {
            document.getElementById("image").src = t.value
        }
    }

    function validURL(str) {
        var pattern = new RegExp('^(https?:\\/\\/)?'+ // protocol
            '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|'+ // domain name
            '((\\d{1,3}\\.){3}\\d{1,3}))'+ // OR ip (v4) address
            '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*'+ // port and path
            '(\\?[;&a-z\\d%_.~+=-]*)?'+ // query string
            '(\\#[-a-z\\d_]*)?$','i'); // fragment locator
        return !!pattern.test(str);
    }

    function save(object) {
        let title = document.getElementById("title").value
        let url = document.getElementById("url").value
        let text = document.getElementById("text").value
        if(text.trim() == "" || title.trim() == "") {
                $('#saveButton').attr('data-content', "Title & text cant be empty.").popover('show')
                setTimeout(() => {
                    $('#saveButton').popover('dispose')
                }, 3500)
        }
        else {
            object.text = text
            object.title = title
            object.url = url
            let error = false;
            fetch("/notice/update", {
                method: "PATCH",
                body: JSON.stringify(object),
                headers: {
                    'Content-Type': 'application/json'
                }
            })
            .then(resp => {
                if(resp.status !== 200) {
                    error = true;
                }
                return resp.json()
            })
            .then(data => {
                if(error) {
                    document.getElementById("errorMsg").innerText = data.message;
                    document.getElementById("errorMsg").style.display = "block"
                }
                else {
                    window.location.href = "/redirectIndex/updated/" + data.data.id
                }
            })
        }

    }
    function returnBack(id) {
        window.location.href = "/notice/" + id
    }
    function deleteNotice(id) {
        if(!confirm("Are you sure you want to delete this?")) return
        let error = false;
        fetch("/notice/" + id, {
            method: "DELETE",
            headers: {
                'Content-Type': 'application/json'
            }
        })
            .then(resp => {
                console.log(resp.status)
                if(resp.status !== 200) {
                    error = true;
                }
                return resp.json()
            })
            .then(json => {
                if(error) {
                    document.getElementById("errorMsg").innerText = json.message;
                    document.getElementById("errorMsg").style.display = "block"
                }
                else {
                    window.location.href = "/redirectIndex/deleted/"
                }
            })
    }
</script>
<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>

</html>